Loading...
Searching...
No Matches
casacore::SSMColumn Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <SSMColumn.h>`

## Public Member Functions

| SSMColumn (SSMBase *aParent, int aDataType, uInt aColNr)
| Create a SSMColumn object with the given parent.
virtual | ~SSMColumn ()
| SSMColumn (const SSMColumn &)=delete
| Forbid copy constructor.
SSMColumn & | operator= (const SSMColumn &)=delete
| Forbid assignment.
virtual void | setShapeColumn (const IPosition &aShape)
| Set the shape of an array in the column.
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of a 'fixed length' string.
virtual uInt | ndim (rownr_t aRowNr)
| Get the dimensionality of the item in the given row.
virtual IPosition | shape (rownr_t aRowNr)
| Get the shape of the array in the given row.
virtual void | doCreate (rownr_t aNrRows)
| Let the object initialize itself for a newly created table.
virtual void | getFile (rownr_t aNrRows)
| Let the column object initialize itself for an existing table.
void | resync (rownr_t aNrRow)
| Resync the storage manager with the new file contents.
virtual void | getBool (rownr_t aRowNr, Bool *aDataPtr)
| Get the scalar value in the given row.
virtual void | getuChar (rownr_t aRowNr, uChar *aDataPtr)
virtual void | getShort (rownr_t aRowNr, Short *aDataPtr)
virtual void | getuShort (rownr_t aRowNr, uShort *aDataPtr)
virtual void | getInt (rownr_t aRowNr, Int *aDataPtr)
virtual void | getuInt (rownr_t aRowNr, uInt *aDataPtr)
virtual void | getInt64 (rownr_t aRowNr, Int64 *aDataPtr)
virtual void | getfloat (rownr_t aRowNr, float *aDataPtr)
virtual void | getdouble (rownr_t aRowNr, double *aDataPtr)
virtual void | getComplex (rownr_t aRowNr, Complex *aDataPtr)
virtual void | getDComplex (rownr_t aRowNr, DComplex *aDataPtr)
virtual void | getString (rownr_t aRowNr, String *aDataPtr)
virtual void | putBool (rownr_t aRowNr, const Bool *aDataPtr)
| Put the scalar value in the given row.
virtual void | putuChar (rownr_t aRowNr, const uChar *aDataPtr)
virtual void | putShort (rownr_t aRowNr, const Short *aDataPtr)
virtual void | putuShort (rownr_t aRowNr, const uShort *aDataPtr)
virtual void | putInt (rownr_t aRowNr, const Int *aDataPtr)
virtual void | putuInt (rownr_t aRowNr, const uInt *aDataPtr)
virtual void | putInt64 (rownr_t aRowNr, const Int64 *aDataPtr)
virtual void | putfloat (rownr_t aRowNr, const float *aDataPtr)
virtual void | putdouble (rownr_t aRowNr, const double *aDataPtr)
virtual void | putComplex (rownr_t aRowNr, const Complex *aDataPtr)
virtual void | putDComplex (rownr_t aRowNr, const DComplex *aDataPtr)
virtual void | putString (rownr_t aRowNr, const String *aDataPtr)
virtual void | getScalarColumnV (ArrayBase &aDataPtr)
| Get the scalar values of the entire column.
virtual void | putScalarColumnV (const ArrayBase &aDataPtr)
| Put the scalar values of the entire column.
virtual void | addRow (rownr_t aNewNrRows, rownr_t anOldNrRows, Bool doInit)
| Add (NewNrRows-OldNrRows) rows to the Column and initialize the new rows when needed.
virtual void | deleteRow (rownr_t aRowNr)
| Remove the given row from the data bucket and possibly string bucket.
uInt | getExternalSizeBytes () const
| Get the size of the dataType in bytes!
uInt | getExternalSizeBits () const
| Get the size of the dataType in bits!
uInt | getColNr ()
| get the sequence number of this column.
void | setColNr (uInt aColNr)
| set the sequence number of this column.
void | removeColumn ()
| If something special has to be done before removing the Column, as is the case with Strings, it can be done here.
Public Member Functions inherited from casacore::StManColumnBase
| StManColumnBase (int dataType)
| Default constructor.
| ~StManColumnBase ()
| StManColumnBase (const StManColumnBase &)=delete
| The object cannot be copied.
StManColumnBase & | operator= (const StManColumnBase &)=delete
| The object cannot be assigned to.
virtual int | dataType () const
| Return the data type of the column.
DataType | dtype () const
Int | elemSize () const
| Return the size of an element of the column's data type.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
virtual Bool | isWritable () const
| Test if data can be put into this column.
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an (variable-shaped) array in the given row.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
virtual Bool | canChangeShape () const
| Can the data manager handle chaging the shape of an existing array?
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
virtual void | getArrayV (rownr_t rownr, ArrayBase &dataPtr)
| Get the array value in the given row.
virtual void | putArrayV (rownr_t rownr, const ArrayBase &data)
| Put the array value into the given row.
virtual void | getArrayColumnV (ArrayBase &data)
| Get all array values in the column.
virtual void | putArrayColumnV (const ArrayBase &data)
| Put all array values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &data)
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &data)
| Put some array values in the column.
virtual void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
| Get a section of the array in the given row.
virtual void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
| Put into a section of the array in the given row.
virtual void | getColumnSliceV (const Slicer &slicer, ArrayBase &data)
| Get a section of all arrays in the column.
virtual void | putColumnSliceV (const Slicer &slicer, const ArrayBase &data)
| Put into a section of all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
| Put into a section of some arrays in the column.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Protected Member Functions

void | shiftRows (char *aValue, rownr_t rowNr, rownr_t startRow, rownr_t endRow)
| Shift the rows in the bucket one to the left when removing the given row.
void | getValue (rownr_t aRowNr)
| Fill the cache with data of the bucket containing the given row.
Char * | getRowValue (Int *data, rownr_t aRowNr)
| Get the bucketnr, offset, and length of a variable length string.
void | putValue (rownr_t aRowNr, const void *aValue)
| Put the given value for the row into the correct data bucket.
void | putValueShortString (rownr_t aRowNr, const void *aValue, const String &string)
| Put the given string for the row into the correct data bucket.
void | getColumnValue (void *anArray, rownr_t aNrRows)
| Get the values for the entire column.
void | putColumnValue (const void *anArray, rownr_t aNrRows)
| Put the values from the array in the entire column.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)

## Protected Attributes

SSMBase * | itsSSMPtr
| Pointer to the parent storage manager.
uInt | itsExternalSizeBytes
| Length of column cell value in storage format (0 = variable length).
uInt | itsExternalSizeBits
uInt | itsColNr
| Column sequence number of this column.
IPosition | itsShape
| The shape of the column.
uInt | itsMaxLen
| The maximum length of a 'fixed length' string.
uInt | itsNrElem
| Number of elements in a value for this column.
uInt | itsNrCopy
| Number of values to be copied.
uInt | itsLocalSize
| The sizeof the datatype in local format.
void * | itsData
| The data in local format.
Conversion::ValueFunction * | itsWriteFunc
| Pointer to a convert function for writing.
Conversion::ValueFunction * | itsReadFunc
| Pointer to a convert function for reading.

## Private Member Functions

void | init ()
| Initialize part of the object.
char * | getDataPtr ()
| Get the pointer to the cache.

## Additional Inherited Members

Static Public Member Functions inherited from casacore::StManColumnBase
static Bool | isNativeDataType (int dtype)
| Test if the given data type is supported by storage managers.

## Detailed Description

A Column in the Standard Storage Manager.

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tStandardStMan

### Prerequisite

- SSMBase
- SSMStringHandler

### Etymology

SSMColumn represents a Column in the Standard Storage Manager.

### Synopsis

SSMColumn is the base class for access to a column stored with the Standard Storage manager. It provides some basic functionality for the derived classes handling direct and indirect arrays.

The main task of SSMColumn is handling the access to a column containing scalars of the various data types. The data is stored in buckets. The classes SSMBase and SSMIndex keep track in which data bucket a given row is stored and at which offset the column starts. Using that information SSMColumn can access its data easily.

Almost all data types have a fixed length and can be handled easily. However, strings are a special case.
If the string is fixed length (which means it has a maximum length), the string is stored directly in the data bucket. If the string is shorter than the maximum length, its length is indicated by a trailing 0.
Variable strings are in principle stored in a special string bucket. The data bucket contains 3 integers telling the bucketnr, offset, and length of the string. However, it the string is short enough (ie. <= 8 characters), the string is stored directly in data bucket using the space for bucketnr and offset.

The class maintains a cache of the data in the bucket last read. This cache is used by the higher level table classes to get faster read access to the data. The cache is not used for strings, because they are stored differently.

Definition at line 97 of file SSMColumn.h.

## Constructor & Destructor Documentation

## SSMColumn() [1/2]

casacore::SSMColumn::SSMColumn | ( | SSMBase * | aParent,
|  | int | aDataType,
|  | uInt | aColNr )

Create a SSMColumn object with the given parent.

It initializes the various variables. It keeps the pointer to its parent (but does not own it).

Referenced by operator=(), and SSMColumn().

## ~SSMColumn()

virtual casacore::SSMColumn::~SSMColumn | ( |  | ) |

virtual

## SSMColumn() [2/2]

casacore::SSMColumn::SSMColumn | ( | const SSMColumn & |  | ) |

delete

Forbid copy constructor.

References SSMColumn().

## Member Function Documentation

## addRow()

virtual void casacore::SSMColumn::addRow | ( | rownr_t | aNewNrRows,
|  | rownr_t | anOldNrRows,
|  | Bool | doInit )

virtual

Add (NewNrRows-OldNrRows) rows to the Column and initialize the new rows when needed.

Reimplemented in casacore::SSMIndColumn.

## deleteRow()

virtual void casacore::SSMColumn::deleteRow | ( | rownr_t | aRowNr | ) |

virtual

Remove the given row from the data bucket and possibly string bucket.

If needed, it also removes it from the cache.

Reimplemented in casacore::SSMDirColumn, and casacore::SSMIndColumn.

## doCreate()

virtual void casacore::SSMColumn::doCreate | ( | rownr_t | aNrRows | ) |

virtual

Let the object initialize itself for a newly created table.

It is meant for a derived class.

Reimplemented in casacore::SSMIndColumn.

## getBool()

virtual void casacore::SSMColumn::getBool | ( | rownr_t | aRowNr,
|  | Bool * | aDataPtr )

virtual

Get the scalar value in the given row.

Reimplemented from casacore::DataManagerColumn.

## getColNr()

uInt casacore::SSMColumn::getColNr | ( |  | ) |

inline

get the sequence number of this column.

Definition at line 290 of file SSMColumn.h.

References itsColNr.

## getColumnValue()

void casacore::SSMColumn::getColumnValue | ( | void * | anArray,
|  | rownr_t | aNrRows )

protected

Get the values for the entire column.

The data from all buckets is copied to the array.

## getComplex()

virtual void casacore::SSMColumn::getComplex | ( | rownr_t | aRowNr,
|  | Complex * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getDataPtr()

char * casacore::SSMColumn::getDataPtr | ( |  | ) |

inline private

Get the pointer to the cache.

It is created if not done yet.

Definition at line 282 of file SSMColumn.h.

References itsColNr, itsData, itsLocalSize, and itsSSMPtr.

## getDComplex()

virtual void casacore::SSMColumn::getDComplex | ( | rownr_t | aRowNr,
|  | DComplex * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getdouble()

virtual void casacore::SSMColumn::getdouble | ( | rownr_t | aRowNr,
|  | double * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getExternalSizeBits()

uInt casacore::SSMColumn::getExternalSizeBits | ( |  | ) | const

inline

Get the size of the dataType in bits!

!

Definition at line 277 of file SSMColumn.h.

References itsExternalSizeBits.

## getExternalSizeBytes()

uInt casacore::SSMColumn::getExternalSizeBytes | ( |  | ) | const

inline

Get the size of the dataType in bytes!

!

Definition at line 272 of file SSMColumn.h.

References itsExternalSizeBytes.

## getFile()

virtual void casacore::SSMColumn::getFile | ( | rownr_t | aNrRows | ) |

virtual

Let the column object initialize itself for an existing table.

Reimplemented in casacore::SSMIndColumn.

## getfloat()

virtual void casacore::SSMColumn::getfloat | ( | rownr_t | aRowNr,
|  | float * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getInt()

virtual void casacore::SSMColumn::getInt | ( | rownr_t | aRowNr,
|  | Int * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getInt64()

virtual void casacore::SSMColumn::getInt64 | ( | rownr_t | aRowNr,
|  | Int64 * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getRowValue()

Char * casacore::SSMColumn::getRowValue | ( | Int * | data,
|  | rownr_t | aRowNr )

protected

Get the bucketnr, offset, and length of a variable length string.

data must have 3 Ints to hold the values. It returns a pointer to the data in the bucket, which can be used for the case that the data bucket contains the (short) string.

## getScalarColumnV()

virtual void casacore::SSMColumn::getScalarColumnV | ( | ArrayBase & | aDataPtr | ) |

virtual

Get the scalar values of the entire column.

Reimplemented from casacore::DataManagerColumn.

## getShort()

virtual void casacore::SSMColumn::getShort | ( | rownr_t | aRowNr,
|  | Short * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getString()

virtual void casacore::SSMColumn::getString | ( | rownr_t | aRowNr,
|  | String * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuChar()

virtual void casacore::SSMColumn::getuChar | ( | rownr_t | aRowNr,
|  | uChar * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuInt()

virtual void casacore::SSMColumn::getuInt | ( | rownr_t | aRowNr,
|  | uInt * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuShort()

virtual void casacore::SSMColumn::getuShort | ( | rownr_t | aRowNr,
|  | uShort * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getValue()

void casacore::SSMColumn::getValue | ( | rownr_t | aRowNr | ) |

protected

Fill the cache with data of the bucket containing the given row.

## init()

void casacore::SSMColumn::init | ( |  | ) |

private

Initialize part of the object.

It determines the nr of elements, the function to use to convert from local to file format, etc..

## ndim()

virtual uInt casacore::SSMColumn::ndim | ( | rownr_t | aRowNr | ) |

virtual

Get the dimensionality of the item in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::SSMIndColumn, and casacore::SSMIndStringColumn.

## operator=()

SSMColumn & casacore::SSMColumn::operator= | ( | const SSMColumn & |  | ) |

delete

Forbid assignment.

References SSMColumn().

## putBool()

virtual void casacore::SSMColumn::putBool | ( | rownr_t | aRowNr,
|  | const Bool * | aDataPtr )

virtual

Put the scalar value in the given row.

It updates the cache if the row is contained in the cache.

Reimplemented from casacore::DataManagerColumn.

## putColumnValue()

void casacore::SSMColumn::putColumnValue | ( | const void * | anArray,
|  | rownr_t | aNrRows )

protected

Put the values from the array in the entire column.

Each data bucket is filled with the appropriate part of the array.

## putComplex()

virtual void casacore::SSMColumn::putComplex | ( | rownr_t | aRowNr,
|  | const Complex * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putDComplex()

virtual void casacore::SSMColumn::putDComplex | ( | rownr_t | aRowNr,
|  | const DComplex * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putdouble()

virtual void casacore::SSMColumn::putdouble | ( | rownr_t | aRowNr,
|  | const double * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putfloat()

virtual void casacore::SSMColumn::putfloat | ( | rownr_t | aRowNr,
|  | const float * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putInt()

virtual void casacore::SSMColumn::putInt | ( | rownr_t | aRowNr,
|  | const Int * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putInt64()

virtual void casacore::SSMColumn::putInt64 | ( | rownr_t | aRowNr,
|  | const Int64 * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putScalarColumnV()

virtual void casacore::SSMColumn::putScalarColumnV | ( | const ArrayBase & | aDataPtr | ) |

virtual

Put the scalar values of the entire column.

It invalidates the cache.

Reimplemented from casacore::DataManagerColumn.

## putShort()

virtual void casacore::SSMColumn::putShort | ( | rownr_t | aRowNr,
|  | const Short * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putString()

virtual void casacore::SSMColumn::putString | ( | rownr_t | aRowNr,
|  | const String * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuChar()

virtual void casacore::SSMColumn::putuChar | ( | rownr_t | aRowNr,
|  | const uChar * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuInt()

virtual void casacore::SSMColumn::putuInt | ( | rownr_t | aRowNr,
|  | const uInt * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuShort()

virtual void casacore::SSMColumn::putuShort | ( | rownr_t | aRowNr,
|  | const uShort * | aDataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putValue()

void casacore::SSMColumn::putValue | ( | rownr_t | aRowNr,
|  | const void * | aValue )

protected

Put the given value for the row into the correct data bucket.

## putValueShortString()

void casacore::SSMColumn::putValueShortString | ( | rownr_t | aRowNr,
|  | const void * | aValue,
|  | const String & | string )

protected

Put the given string for the row into the correct data bucket.

The argument aValue> must be 3 Ints (for bucketnr, offset, and length). Only the length is actually used.

## removeColumn()

void casacore::SSMColumn::removeColumn | ( |  | ) |

If something special has to be done before removing the Column, as is the case with Strings, it can be done here.

## resync()

void casacore::SSMColumn::resync | ( | rownr_t | aNrRow | ) |

Resync the storage manager with the new file contents.

It resets the last rownr put.

## setColNr()

void casacore::SSMColumn::setColNr | ( | uInt | aColNr | ) |

inline

set the sequence number of this column.

Definition at line 295 of file SSMColumn.h.

References itsColNr.

## setMaxLength()

virtual void casacore::SSMColumn::setMaxLength | ( | uInt | maxLength | ) |

virtual

Set the maximum length of a 'fixed length' string.

It is only called (right after the constructor) if the string has a fixed length.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::SSMDirColumn, and casacore::SSMIndColumn.

## setShapeColumn()

virtual void casacore::SSMColumn::setShapeColumn | ( | const IPosition & | aShape | ) |

virtual

Set the shape of an array in the column.

It is only called (right after the constructor) if the array has a fixed shape.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::SSMIndColumn.

## shape()

virtual IPosition casacore::SSMColumn::shape | ( | rownr_t | aRowNr | ) |

virtual

Get the shape of the array in the given row.

Reimplemented from casacore::DataManagerColumn.

Reimplemented in casacore::SSMIndColumn, and casacore::SSMIndStringColumn.

## shiftRows()

void casacore::SSMColumn::shiftRows | ( | char * | aValue,
|  | rownr_t | rowNr,
|  | rownr_t | startRow,
|  | rownr_t | endRow )

protected

Shift the rows in the bucket one to the left when removing the given row.

## Member Data Documentation

## itsColNr

uInt casacore::SSMColumn::itsColNr

protected

Column sequence number of this column.

Definition at line 241 of file SSMColumn.h.

Referenced by getColNr(), getDataPtr(), and setColNr().

## itsData

void* casacore::SSMColumn::itsData

protected

The data in local format.

Definition at line 255 of file SSMColumn.h.

Referenced by getDataPtr().

## itsExternalSizeBits

uInt casacore::SSMColumn::itsExternalSizeBits

protected

Definition at line 239 of file SSMColumn.h.

Referenced by getExternalSizeBits().

## itsExternalSizeBytes

uInt casacore::SSMColumn::itsExternalSizeBytes

protected

Length of column cell value in storage format (0 = variable length).

Definition at line 238 of file SSMColumn.h.

Referenced by getExternalSizeBytes().

## itsLocalSize

uInt casacore::SSMColumn::itsLocalSize

protected

The sizeof the datatype in local format.

Definition at line 253 of file SSMColumn.h.

Referenced by getDataPtr().

## itsMaxLen

uInt casacore::SSMColumn::itsMaxLen

protected

The maximum length of a 'fixed length' string.

Definition at line 245 of file SSMColumn.h.

## itsNrCopy

uInt casacore::SSMColumn::itsNrCopy

protected

Number of values to be copied.

Normally this is itsNrElem, but for complex types it is 2*itsNrElem. When local format is used, it is the number of bytes.

Definition at line 251 of file SSMColumn.h.

## itsNrElem

uInt casacore::SSMColumn::itsNrElem

protected

Number of elements in a value for this column.

Definition at line 247 of file SSMColumn.h.

## itsReadFunc

Conversion::ValueFunction* casacore::SSMColumn::itsReadFunc

protected

Pointer to a convert function for reading.

Definition at line 259 of file SSMColumn.h.

## itsShape

IPosition casacore::SSMColumn::itsShape

protected

The shape of the column.

Definition at line 243 of file SSMColumn.h.

## itsSSMPtr

SSMBase* casacore::SSMColumn::itsSSMPtr

protected

Pointer to the parent storage manager.

Definition at line 236 of file SSMColumn.h.

Referenced by getDataPtr().

## itsWriteFunc

Conversion::ValueFunction* casacore::SSMColumn::itsWriteFunc

protected

Pointer to a convert function for writing.

Definition at line 257 of file SSMColumn.h.

The documentation for this class was generated from the following file:

- tables/DataMan/SSMColumn.h